#include<bits/stdc++.h>
using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(NULL); cout.tie(NULL);
	int t, n, m;
	long long a[10010], b[10010];
	bool bb[6];
	cin>>t;
	for(int i=0; i<t; i++)
	{
		cin>>n>>m;
		long long x, d, mind;
		bb[i]=true;
		for(int j=0; j<n; j++) 
		{
			cin>>a[j];
		}
		mind=abs(a[1]-a[0]);
		for(int j=2; j<n && bb[i]; j++) 
		{
			d=__gcd(mind,abs(a[j]-a[j-1]));
			if(d==1) bb[i]=false;
			else mind=d; 
			
		}
		for(int k=0; k<m; k++) 
		{
			cin>>b[k];
			if(bb[i] && (b[k]-a[0])%mind==0) bb[i]=false;
		}
	}
	for(int i=0; i<t; i++) 
	{
		if(bb[i]) cout<<1<<endl;
		else cout<<0<<endl;
	}
}